#include <QCoreApplication>
#include <QtDBus/QDBusConnection>
#include <QtDebug>

#include "common.h"
#include "screen.h"
#include "audio.h"
#include "network.h"
#include "bluetooth.h"
#include "power.h"
#include "touchpad.h"

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    // Todo
    // 启动后台服务，加载Dbus接口,注册DBus对象
    QDBusConnection sessionBus = QDBusConnection::sessionBus();
    if (sessionBus.registerService(DBUS_NAME)) {
        sessionBus.registerObject(DEVICES_SCREEN_PATH, new Screen(),
                                 QDBusConnection::ExportAllSlots | QDBusConnection::ExportAllSignals
                                 );
        sessionBus.registerObject(DEVICES_AUDIO_PATH, new Audio(),
                                 QDBusConnection::ExportAllSlots | QDBusConnection::ExportAllSignals
                                 );
        BLUETOOTHDBUS::instance();
        sessionBus.registerObject(DEVICES_BLUETOOTH_PATH, BLUETOOTHDBUS::getInstance(),
                                 QDBusConnection::ExportAllSlots | QDBusConnection::ExportAllSignals
                                 );
        sessionBus.registerObject(DEVICES_WIFI_PATH, new Network(),
                                 QDBusConnection::ExportAllSlots | QDBusConnection::ExportAllSignals
                                 );
        sessionBus.registerObject(DEVICES_POWER_PATH, new UkuiPowerInterface(),
                                 QDBusConnection::ExportAllSlots | QDBusConnection::ExportAllSignals
                                 );
        
        sessionBus.registerObject(DEVICES_TOUCHPAD_PATH, new TouchpadManager(),
                                 QDBusConnection::ExportAllSlots | QDBusConnection::ExportAllSignals
                                 );
    }

    return a.exec();
}
